﻿import { Component,OnInit, ViewChild,ChangeDetectorRef,HostListener} from '@angular/core';

import { Router ,Params,NavigationEnd,ActivatedRoute} from '@angular/router';

import {RetsService,UserService } from '../_services/index';

import {SlimLoadingBarService} from 'ng2-slim-loading-bar';

import {PaginationInstance} from '../../../node_modules/ngx-pagination/dist/ngx-pagination.module';

import {AgmCoreModule} from 'angular2-google-maps/core';

import { Marker } from '../_models/index';

import { trigger,state,style,animate,transition } from '@angular/animations';

import { IMultiSelectOption,IMultiSelectTexts,IMultiSelectSettings } from 'angular-2-dropdown-multiselect';

import { RegisterComponent } from '../register/index';

import {global} from '../global';

import {MatDialog, MatDialogConfig, MatDialogRef, MAT_DIALOG_DATA} from '@angular/material';

import {SaveSearchComponent} from '../savesearch';

@Component({
   moduleId: module.id.toString(),
   animations: [
   trigger('heroState', [
    transition('inactive => active', animate('100ms ease-in')),
    transition('active => inactive', animate('100ms ease-out')),
    transition('inactive => void', [
      animate(400, style({transform: 'translateY(-100%) scale(1)'}))
    ]),
    transition('active => void', [
      animate(400, style({transform: 'translateY(0) scale(0)'}))
    ])
  ])
],
  	templateUrl: 'listing.component.html',
    entryComponents: [
    	RegisterComponent,
    	SaveSearchComponent
  	]
})

export class ListingComponent {
    foreclosures: IMultiSelectOption[];
    description_lot: IMultiSelectOption[];
    subtype: IMultiSelectOption[];
    floorplan: IMultiSelectOption[];
    school_district: IMultiSelectOption[];
    searchtext:string="Search";
	
	// Settings configuration
	mySettings: IMultiSelectSettings = {
		enableSearch: false,
		checkedStyle: 'glyphicon',
		buttonClasses: 'btn-multiselect',
		dynamicTitleMaxItems: 2,
		displayAllSelectedText: true,
		closeOnSelect :false,
		maxHeight : '400px',
		containerClasses : 'advance-dropdown'
	};
	
	// Text configuration
	myTexts: IMultiSelectTexts = {
		defaultTitle: 'Select Foreclosure',
		allSelected: 'All selected',
	};
	lotTexts: IMultiSelectTexts = {
		defaultTitle: 'Select Lot description',
		allSelected: 'All selected',
	};
	subtypeTexts: IMultiSelectTexts = {
		defaultTitle: 'Property Type',
		allSelected: 'All selected',
	};
	floorplanTexts: IMultiSelectTexts = {
		defaultTitle: 'Select floor plans',
		allSelected: 'All selected',
	};
	school_districtTexts: IMultiSelectTexts = {
		defaultTitle: 'Select School District',
		allSelected: 'All selected',
	};

	favdata : any;
	test :number=3;
	public state = 'inactive';
	//public astate = 'inactive';
	showLoadmore :boolean= false;
	row : number = 1;
	rowperpage : number = 30;
	buttonText :string = "Load More";
	clickedmarker : boolean =false;
	zoom: number = 9;
	showmap : boolean=true;
	showoption : boolean=true;
	lat: number=38.858792853706;
	lng: number=-104.7434625;
	markers: any[] = []; 
	totalresult :any[]=[];
	showmaptext:string="Hide Map";
	advsearchtext:string="Less Options";
	searchpropeties : any = {};
	qparam : any;
	propertiescount : any;
	enablegrid:boolean=true;
	enablelist:boolean=false;
	gridclass:string='grid current';
	listclass:string='list';
	infoWindowOpened :any = null;
	advancemodel : any ={};
	ssmodel : any ={};
  	searchdata:any={};
  	currentUser: any;
  	gettingres:boolean=false;
	
	/***************sorting ****************/	
	key: string = 'OriginalEntryTimestamp'; //set default
	reverse: boolean = true;
	selected_state:any='OriginalEntryTimestamp-asc';
	
	/********pagination controls ***********/
	public filter: string = '';
	public maxSize: number = 7;
	public directionLinks: boolean = true;
	public autoHide: boolean = false;
	totalpages : any;
    clickeddata : any={};
	public loading = false;
    public config: PaginationInstance = {
        id: 'advanced',
        itemsPerPage: 30,
        currentPage: 1
    };
    public labels: any = {
        previousLabel: 'Previous',
        nextLabel: 'Next',
        screenReaderPaginationLabel: 'Pagination',
        screenReaderPageLabel: 'page',
        screenReaderCurrentLabel: `You're on page`
    };
    rmfv:boolean =false;
	adsfv : boolean =true;
    setting : any;
    abovefooter_img :string;
    baseurl =global.imagepath;
    globallink =global.globallink;
    liveurl=global.liveurl;
    retsurl=global.retsurl;
    retsimageurl=global.retsimageurl;
    iconurl : string;
    innerWidth : any;
    showedit:boolean=false;
    hidesave:boolean=true;
    currentUrl : string;
    retval:boolean;
    editsearch:boolean=false;
    seavesearchid:any='';
    showextrafields:boolean=false;
    @ViewChild('f') form: any;
    
    constructor(private cdRef: ChangeDetectorRef,
				private slimLoadingBarService: SlimLoadingBarService,
				private router: Router,
				private route: ActivatedRoute,
				private retsService: RetsService,
				private userService: UserService,
			 	public dialog: MatDialog) {
    				this.setting={};
					this.iconurl=this.liveurl+'map-home_2x.png';
					this.rmfv=false;
					this.adsfv=true;
					this.advancemodel.beds='';
					this.advancemodel.baths='';
					this.advancemodel.builder_name='';
					this.advancemodel.property_size_min='';
					this.advancemodel.property_size_max='';
					this.advancemodel.year_built_min='';
					this.advancemodel.year_built_max='';
					this.advancemodel.finished_basement='';
					this.advancemodel.lot_size_min='';
					this.advancemodel.lot_size_max='';
					this.advancemodel.garage_number_min='';
					this.advancemodel.garage_number_max='';
					this.advancemodel.master_main_level='';
					this.advancemodel.walkout_basement='';
					this.advancemodel.air_conditioning='';
					this.advancemodel.page_number='1';
					this.advancemodel.page_limit='30';
					let currentUser = JSON.parse(localStorage.getItem('currentUser'));

					if(route.snapshot.queryParams['googleapi'])
                  	{
                  	this.showextrafields=true;
                  	this.advancemodel.minimum_bedrooms=route.snapshot.queryParams['minimum_bedrooms'];
                  	this.advancemodel.maximum_bedrooms=route.snapshot.queryParams['maximum_bedrooms'];
                  	this.advancemodel.minimum_bathrooms=route.snapshot.queryParams['minimum_bathrooms'];
                  	this.advancemodel.maximum_bathrooms=route.snapshot.queryParams['maximum_bathrooms'];
                  	}

					if(currentUser)
					{
						userService.getallfavorite(currentUser).subscribe(data =>this.favdata=data);
					}

					router.events.subscribe((event: any) => {
                		if (event instanceof NavigationEnd ) {
                  			this.currentUrl=event.url;
                  			if(this.currentUrl.indexOf('idx/search') > 0 ){
                  				console.log(this.currentUrl);
			                  	let url = this.currentUrl.split('/');
			                    this.seavesearchid = url[3];
			                    this.getsavesearch(url[3]);
			                    if(route.snapshot.queryParams['edit']){
			                      this.editsearch=true;
			                    }
			                }
							else
							{
					          	if(route.snapshot.queryParams['search_location'])
					          	{
					          		this.qparam=route.snapshot.queryParams['search_location'];
					          	}
					          	else
					          	{
					          		this.qparam='all_listings';
					          		//this.advancemodel.userSearchQuery=this.qparam;
					          	}
	      						
	      						this.getresult(this.qparam,1,30);
                  			}
                		}
              		});
							
					/******************* get above footer content *****************/
					userService.getsetting().subscribe(
						data=>{
								this.setting=data.setting;
								this.abovefooter_img=this.baseurl+ this.setting.abovefooter_img;
							},
						error =>{}
						);
				}

	ngOnInit() {
	
		this.innerWidth = window.innerWidth;
		if (innerWidth < 950) {
			  this.test = 2;
		}

		if (innerWidth > 950) {
		  this.test = 3;
		}

		if (innerWidth < 750) {
		  this.test = 1;
		}

        this.foreclosures = [
			{ id: 'search_foreclosure_y', name: ' Search Foreclosure' },
            { id: 'search_foreclosure_n', name: 'Exclude Foreclosure' },
            { id: 'search_shortsale_y', name: 'Search Short Sale' },
            { id: 'search_shortsale_n', name: 'Exclude Short Sale' },
            { id: 'search_bankowned_y', name: 'Search Bank Owned' },
            { id: 'search_bankowned_n', name: 'Exclude Bank Owned' }
        ];

        this.description_lot=[
        {id:"0.0000 sqft.",name:'0.0000 Sqft.'},
        {id:"360-degree View",name:'360-degree View'},
        {id:"Backs to City/Cnty/State/Natl OS",name:'Backs To City/cnty/state/natl Os'},
        {id:"Backs to Golf Course",name:'Backs To Golf Course'},
        {id:"Backs to Open Space (OS)",name:' Backs To Open Space (os)'},
        {id:"City View",name:'City View'},
        {id:"Corner",name:'Corner'},
        {id:"Cul-de-sac",name:'Cul-de-sac'},
        {id:"Flag Lot",name:'Flag Lot'},
        {id:"Hillside",name:'Hillside'},
        {id:"Level",name:'Level'},
        {id:"Meadow",name:'Meadow'},
        {id:"Mountain View",name:'Mountain View'},
        {id:"Rural",name:'Rural'},
        {id:"See Prop Desc Remarks",name:'See Prop Desc Remarks'},
        {id:"Sloping",name:'Sloping'},
        {id:"Trees/Woods",name:'Trees/woods'},
        {id:"View of Pikes Peak",name:'View Of Pikes Peak'},
        {id:"Mountain View",name:'Mountain View'},
        {id:"Trees/woods",name:'Trees/woods'},
        {id:"View Of Pikes Peak",name:'View Of Pikes Peak'},
        {id:"Sloping",name:'Sloping'},
        {id:"See Prop Desc Remarks",name:'See Prop Desc Remarks'},
        {id:"View Of Rock Formations",name:'View Of Rock Formations'},
        {id:"Foothill",name:'Foothill'},
        {id:"Stream/creek",name:'Stream/creek'},
        {id:"Spring/pond/lake",name:'Spring/pond/lake'},
        {id:"Golf Course View",name:'Golf Course View'},
        {id:"Borders Natl Forest",name:'Borders Natl Forest'},
        {id:"Borders Blm",name:'Borders Blm'},
        {id:"Lake/stream",name:'Lake/stream'}
        ];

        this.subtype=[
			{id:"single_family",name:'Single Family'},
			{id:"townhouse",name:'Townhouse'},
			{id:"condominium",name:'Condominium'},
			{id:"patio_home",name:'Patio Home'},
		];

		this.floorplan=[
			{id:"1.5 Story",name:'1.5 Story'},
			{id:"2 Story",name:'2 Story'},
			{id:"3 Story",name:'3 Story'},
			{id:"4-Levels",name:'4 Levels'},
			{id:"5 Levels or More",name:'5 Levels or More'},
			{id:"Ranch",name:'Ranch'},
			{id:"Raised Ranch",name:'Raised Ranch'},
			{id:"Bi-level",name:'Bi-Level'},
			{id:"Tri-Level",name:'Tri-Level'},
		];

		this.school_district=[
			{id:"Big Sandy",name:'100j-big Sandy'},
			{id:"Colorado Springs",name:'11-colorado Springs'},
			{id:"Cheyenne Mountain",name:'12-cheyenne Mountain'},
			{id:"Manitou Springs",name:'14-manitou Springs'},
			{id:"Harrison",name:'2-harrison'},
			{id:"Academy",name:'20-academy'},
			{id:"Elbert",name:'200-elbert'},
			{id:"Ellicott",name:'22-ellicott'},
			{id:"Peyton",name:'23jt-peyton'},
			{id:"Hanover",name:'28-hanover'},
			{id:"Widefield",name:'3-widefield'},
			{id:"Lewis-Palmer",name:'38-lewis-palmer'},
			{id:"Falcon",name:'49-falcon'},
			{id:"J",name:'4j'},
			{id:"Pueblo",name:'60-pueblo'},
			{id:"Miami/Yoder",name:'60jt-miami/yoder'},
			{id:"Pueblo",name:'70-pueblo'},
			{id:"Fountain",name:'8-fountain'},
			{id:"Custer Consolidated",name:'C-1-custer Consolidated'},
			{id:"Elizabeth",name:'C-1-elizabeth'},
			{id:"Kiowa",name:'C-2-kiowa'},
			{id:"DOU",name:'Dou'},
			{id:"Other",name:'Other'},
			{id:"Buena Vista",name:'Dou'},
			{id:"Canon City",name:'Re-1-canon City'},
			{id:"Fremont",name:' Re-2 Fremont'},
			{id:"Park",name:'Re-2-park'},
			{id:"RE1",name:'Re1'},
			{id:"RE2",name:'Re2'},
			{id:"RE3",name:'Re3'},
			{id:"RJ1",name:'Rj1'},
		];
    }
     onChange() {
     // console.log(this.advancemodel.foreclosure);
    }
    addtofavorite(mlsnumber : number,article:any)
		{
			let currentUser = JSON.parse(localStorage.getItem('currentUser'));
			if(currentUser)
			{
				this.userService.addtofavorite(currentUser,mlsnumber,article).subscribe(
				data =>{
					if(data.added)
					{
					article.isfave=true;	
					}
				},
				error =>{

				}
				);
			}
			else
			{
				const dialogregRef = this.dialog.open(RegisterComponent);
				
			}
		}
		removetofavorite(mlsnumber : number,article:any){
			let currentUser = JSON.parse(localStorage.getItem('currentUser'));
			this.userService.removefavorite(currentUser,mlsnumber).subscribe(
					data =>{
						
						if(data.removed)
						{
						article.isfave=false;
							
						}
					},
					error =>{

					}
					);
		} 		
	sort(key :any){
		let x = key.split("-");
		this.key = x[0];
		if(x[1]=='asc')
		{
			this.reverse = true;
		}
		else
		{
			this.reverse = false;
		}
  }					
	getresult(qparam : string,pagnumber:number,pagelimit:number)
	{
		this.loading = true;
		//this.markers=[];
		 let para={"userSearchQuery": qparam,'page_number':pagnumber,'page_limit':pagelimit};	
			this.retsService.searchproperties(para).subscribe(
			data =>{
					if(data.success)
					{
						this.loading = false;
						this.buttonText = "Load More";
						if(data.total_count>30)
						{
							this.showLoadmore=true;
						}
						this.propertiescount=data.total_count;
						this.searchpropeties=data;	
						
						
						for(let element of this.searchpropeties.data){
							element.isfave=false;
							if(this.favdata)
							{
								for(let currentfav of this.favdata.allfavs)
								{
									if(element.MLSNumber == currentfav.propertyid)
									{	
										element.isfave=true;
									}			
								}
							}
						this.totalresult.push(element);
						this.markers.push({
							  lat: parseFloat(element.Latitude),
							  lng: parseFloat(element.Longitude),
							  draggable: false,
							  MLSNumber:element.MLSNumber,
							  AcresTotal:element.AcresTotal,
							  BathsFull:element.BathsFull,
							  BedsTotal:element.BedsTotal,
							  City:element.City,
							  ListPrice:element.ListPrice,
							  PostalCode:element.PostalCode,
							  SqftTotal:element.SqftTotal,
							  StreetName:element.StreetName,
							  StreetNumber:element.StreetNumber,
							  photos:element.photos,
							  Matrix_Unique_ID : element.Matrix_Unique_ID,
							  label:null
							});
							}
							this.getCenterMarkers();
						}
						else
						{
							this.loading = false;
							this.showLoadmore=false;
						}
				
					},
			error =>{this.loading = false;}
		);
	}
					
	onPageChange() {
		this.loading = true;
		this.buttonText = "Loading ...";
		this.row=this.row+1;
		this.searchadvance(this.row,30);
		//console.log(this.qparam);
		//this.sort(this.selected_state);
		//console.log();
        this.config.currentPage = this.row;
    }

    showgrid(){
		this.enablegrid=true;
		this.enablelist=false;
		this.gridclass='grid current';
		this.listclass='list';
    }

	showlist(){
		this.enablegrid=false;
		this.enablelist=true;
		this.gridclass='grid';
		this.listclass='list current';
	}
	  
  /*************** Google map **************/
	 clickedMarker(infoWindow:any,property: any,markernum:number) {
		this.clickedmarker=true;
		this.clickeddata=property;
		if( this.infoWindowOpened ===  infoWindow)
		return;
      
		if(this.infoWindowOpened !== null)
		this.infoWindowOpened.close();
		this.infoWindowOpened = infoWindow;
  }
     hovervent(infoWindow:any,property: any,markernum:number) {
		if(!this.clickedmarker)
		{
			this.clickeddata=property;
			this.infoWindowOpened =  infoWindow;
			this.infoWindowOpened.open();
		}
  }
  closeinfowindow(infoWindow:any,markernum:number)
  {
	if(!this.clickedmarker)
	{
		if(this.infoWindowOpened !== null)
		this.infoWindowOpened.close();
		this.infoWindowOpened = infoWindow;
	}
  }
  onInfoWindowClose(event:any)
  {
	 this.clickedmarker=false;
   
  }

  
  markerDragEnd(m: Marker, $event: any) {
    console.log('dragEnd', m, $event);
  }
  getCenterMarkers(): void{

    let lat: number = 0;
    let lng: number = 0;

    this.markers.forEach(marker => {
        lat += marker.lat;
        lng += marker.lng;
    });

    this.lat = lat/this.markers.length;
    this.lng = lng/this.markers.length;
}
showhidemap(){
    this.state === 'active' ? 'inactive' : 'active';
	this.showmap=!this.showmap;
	if(this.showmap == false)
	{
		this.showmaptext="Show Map";
	}
	else
	{
		this.showmaptext="Hide Map";
	}
}
showhideoption()
{
	//this.astate === 'active' ? 'inactive' : 'active';
	this.showoption=!this.showoption;
	if(this.showoption == false)
	{
		this.advsearchtext="More Option";
	}
	else
	{
		this.advsearchtext="Less Options";
	}
}
onResize(event : any) {
    const element = event.target.innerWidth;
    if (element < 950) {
      this.test = 2;
    }

    if (element > 950) {
      this.test = 3;
    }

    if (element < 750) {
      this.test = 1;
    }
  }
 searchadvance(pagenumber:number,pagelimit:number)
 {
   this.gettingres = false;
   this.showoption=true;
   this.searchtext="searching..";
   
   if(pagenumber > 1)
   {
	this.advancemodel.page_number=pagenumber;
   }
	if(this.advancemodel.page_number==1)
	{
		this.totalresult=[];
		this.markers=[];
	}
		
	this.retsService.advancesearch(this.advancemodel).subscribe(
		data =>{
					this.searchtext="Search";
					if(data.success)
					{
							//console.log(data.success);
							
							this.loading = false;
							this.buttonText = "Load More";
							if(data.total_count>30)
							{
								this.showLoadmore=true;
							}
							this.propertiescount=data.total_count;
							this.searchpropeties=data;
							for(let element of this.searchpropeties.data){
							element.isfave=false;
							if(this.favdata)
							{
								for(let currentfav of this.favdata.allfavs)
								{
									if(element.MLSNumber == currentfav.propertyid)
									{	
										element.isfave=true;
									}			
								}
							}
							this.totalresult.push(element);
							this.markers.push({
								  lat: parseFloat(element.Latitude),
								  lng: parseFloat(element.Longitude),
								  draggable: false,
								  MLSNumber:element.MLSNumber,
								  AcresTotal:element.AcresTotal,
								  BathsFull:element.BathsFull,
								  BedsTotal:element.BedsTotal,
								  City:element.City,
								  ListPrice:element.ListPrice,
								  PostalCode:element.PostalCode,
								  SqftTotal:element.SqftTotal,
								  StreetName:element.StreetName,
								  StreetNumber:element.StreetNumber,
								  photos:element.photos,
								  Matrix_Unique_ID : element.Matrix_Unique_ID,
								  label:null
								});
							}
								this.getCenterMarkers();
							//this.cdRef.detectChanges();
							
							this.sort(this.selected_state);
							console.log(this.totalresult);
						}
						else
						{
						
							this.loading = false;
							this.showLoadmore=false;
							this.propertiescount=data.total_count;
						}
				
					},
			error =>{this.loading = false;}
		);
 }
 addsavesearch() {
 const dialogRef = this.dialog.open(SaveSearchComponent,{data:this.advancemodel});

 dialogRef.afterClosed().subscribe(result => {
   if(result){
   if(result.data.val){
     this.hidesave=false;
     this.showedit=true;
     this.router.navigate(['idx/search/'+result.data.id]);
   } else{
     this.hidesave=true;
     this.showedit=false;
   }
  }
 });
 }

 getsavesearch(id:string){

   this.userService.getsavesearch(id).subscribe(
   data =>{
       if(data.error == false)
       {
           //console.log(data.success);
           this.gettingres = true;
           this.loading = false;
           this.hidesave=false;
           this.showedit=true;
        //console.log(data.sdata);
        this.ssmodel.title = data.sdata.title;
        this.ssmodel.efrequecy = data.sdata.efreq;
        let nd = data.sdata.search_url;
        let paramsn = nd.split('&');

        /*for(var i=0;i<paramsn.length;i++){
          let val = paramsn[i].split('=');
          //console.log(val[0]);
          var mv = val[0];
          this.advancemodel[mv] = val[1];
        }*/
        this.advancemodel = data.sdata.mval;
        this.retval=true;
         }
         else
         {
           this.retval=false;
           this.loading = false;
           this.showLoadmore=false;
           this.propertiescount=data.total_count;
         }

       },
   error =>{this.loading = false;this.retval=false;},
   ()=>{
   //console.log(this.advancemodel);
   this.advancemodel.page_number='1';
   this.advancemodel.page_limit='30';
    this.searchadvance(this.advancemodel.page_number,this.advancemodel.page_limit);
    });
 }

openeditsearch(){
this.editsearch=true;
}

editsavesearch(){
  this.loading = true;
  this.searchdata=this.advancemodel;
  this.searchdata.user=this.ssmodel;
this.currentUser = JSON.parse(localStorage.getItem('currentUser'));

if(this.currentUser.id){
this.searchdata.userid = this.currentUser.id;
this.searchdata.ssid = this.seavesearchid;
  this.slimLoadingBarService.start(() => { });
      this.userService.updatesavesearch(this.searchdata)
  .subscribe(
    data =>{
      if(data.error)
      {
        /* if email is already exists */
        this.loading = false;

        this.slimLoadingBarService.stop();
      }
      else
      {
        /* successfull registration */
        //this.myForm.resetForm();
        this.editsearch=false;
        this.loading = false;
        this.slimLoadingBarService.complete();
        this.getsavesearch(this.seavesearchid);
      }
    },
    error =>{

      alert("Sorry, something wet wrong. Please try again");

      this.loading = false;

      this.slimLoadingBarService.stop();
    });
  } else{
    alert("Saved search could not be found.");
    this.loading = false;
    this.slimLoadingBarService.stop();
  }
} 				
}
